﻿using Android.App;
using Android.Content.PM;
using Android.OS;
using Android.Views;
using SampleApp;
using SampleApp.Droid;
using System.Collections;
using Telerik.XamarinForms.DataControlsRenderer.Android;

[assembly: Xamarin.Forms.ExportRenderer(typeof(CustomListView), typeof(CustomListViewRenderer))]
namespace SampleApp.Droid
{
    [Activity(Label = "SampleApp", Icon = "@drawable/icon", MainLauncher = true, ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation)]
    public class MainActivity : global::Xamarin.Forms.Platform.Android.FormsApplicationActivity
    {
        protected override void OnCreate(Bundle bundle)
        {
            base.OnCreate(bundle);

            global::Xamarin.Forms.Forms.Init(this, bundle);
            Telerik.XamarinForms.Common.Android.TelerikForms.Init();
            this.LoadApplication(new App());
        }
    }

    public class CustomListViewRenderer : ListViewRenderer
    {
        protected override void OnElementChanged(Xamarin.Forms.Platform.Android.ElementChangedEventArgs<Telerik.XamarinForms.DataControls.RadListView> e)
        {
            base.OnElementChanged(e);
            
            var listView = this.Control.ListView;
            listView.AddItemClickListener(new LongPressListener(this.Element));
        }
    }

    public class LongPressListener : Java.Lang.Object, Com.Telerik.Widget.List.RadListView.IItemClickListener
    {
        private readonly CustomListView listView;

        public LongPressListener(Telerik.XamarinForms.DataControls.RadListView radListView)
        {
            this.listView = radListView as CustomListView;
        }

        public void OnItemClick(int p0, MotionEvent p1)
        {
        }

        public void OnItemLongClick(int postion, MotionEvent motionEvent)
        {
            this.listView.RaiseLongPress((listView.ItemsSource as IList)[postion]);
        }
    }
}